> ## Documentation Index
> Fetch the complete documentation index at: https://docs.meitner.se/llms.txt
> Use this file to discover all available pages before exploring further.

# Search AuditEvents

> Search for `AuditEvents` with filtering capabilities.



## OpenAPI

````yaml https://spec.speakeasy.com/meitner-2u8/api/directory-api-with-code-samples post /audit-event/_search
openapi: 3.1.0
info:
  title: Directory API
  description: Generated API documentation
  contact:
    name: Meitner
    url: https://meitner.se
    email: support@meitner.se
  license:
    name: Proprietary - Licensed to Authorized Customers Only
    url: https://meitner.se
  version: v1
servers:
  - url: https://api.meitner.se/directory/v1
    description: Server to use in production
    x-speakeasy-server-id: production
  - url: https://api.staging.meitner.se/directory/v1
    description: Server to use when building and testing the API
    x-speakeasy-server-id: staging
security:
  - ClientCredentials: []
    ClientSecret: []
  - OAuth2: []
tags:
  - name: School
    description: >
      The `School` resource represents a school where daily operations occur. A
      school must exist before you can create StudentPlacements,
      EmployeePlacements, or Groups.
       
      This resource can be created, updated, listed, retrieved, and searched
      using the standard resource structure.
  - name: Group
    description: Group holds the information about a group of students.
  - name: Employee
    description: >-
      Employee holds the personal information about an employee in the
      organization.
  - name: EmployeePlacement
    description: >-
      EmployeePlacement holds the information about an employee's placement in a
      school.
  - name: Guardian
    description: Guardian holds the information about a guardian of a student.
  - name: Student
    description: >-
      Student holds the personal information about a student, information about
      the school is stored in the StudentPlacement-resource.
  - name: StudentPlacement
    description: >-
      StudentPlacement holds the placement information about a student in a
      specific school.
  - name: AuditEvent
    description: AuditEvent holds the information about an audit event.
  - name: GradeElementary
    description: >
      GradeElementary represents a grade awarded to a student in elementary
      school (Swedish: grundskola).

      Grades are scoped to the organization of the API key used. The SubjectCode
      field uses the subject code as defined by the Swedish school authorities
      (e.g. "MA" for Mathematics).
  - name: GradeUpperSecondary
    description: >
      GradeUpperSecondary represents a grade awarded to a student in upper
      secondary school (Swedish: gymnasieskola).

      Grades are scoped to the organization of the API key used. The CourseCode
      field uses the national course code as defined by the Swedish school
      authorities (e.g. "MATMAT01a").
  - name: Unit
    description: >
      The `Unit` resource represents an organizational unit that schools can
      belong to.

      This resource can be created, updated, listed, retrieved, and searched
      using the standard resource structure.
paths:
  /audit-event/_search:
    post:
      tags:
        - AuditEvent
      summary: Search AuditEvents
      description: Search for `AuditEvents` with filtering capabilities.
      operationId: AuditEventSearch
      parameters:
        - name: limit
          in: query
          description: >-
            The maximum number of AuditEvents to return (default: 50) when
            searching AuditEvents
          required: false
          schema:
            type: integer
            examples:
              - 1
            default: 50
        - name: offset
          in: query
          description: >-
            The number of AuditEvents to skip before starting to return results
            (default: 0) when searching AuditEvents
          required: false
          schema:
            type: integer
            examples:
              - 0
            default: 0
      requestBody:
        $ref: '#/components/requestBodies/AuditEventSearch'
      responses:
        '200':
          $ref: '#/components/responses/AuditEventSearch'
          description: >-
            Response for AuditEvent Search operation - returns filtered
            AuditEvent results
        '400':
          $ref: '#/components/responses/Error400ResponseBody'
          description: >-
            Bad Request error for AuditEvent Search operation - request contains
            invalid parameters
        '401':
          $ref: '#/components/responses/Error401ResponseBody'
          description: >-
            Unauthorized error for AuditEvent Search operation - authentication
            required
        '403':
          $ref: '#/components/responses/Error403ResponseBody'
          description: >-
            Forbidden error for AuditEvent Search operation - insufficient
            permissions
        '404':
          $ref: '#/components/responses/Error404ResponseBody'
          description: >-
            Not Found error for AuditEvent Search operation - resource does not
            exist
        '409':
          $ref: '#/components/responses/Error409ResponseBody'
          description: >-
            Conflict error for AuditEvent Search operation - request conflicts
            with current state
        '422':
          $ref: '#/components/responses/AuditEventSearch422ResponseBody'
          description: >-
            Validation error for AuditEvent Search operation - request data
            failed validation
        '429':
          $ref: '#/components/responses/Error429ResponseBody'
          description: Rate Limit error for AuditEvent Search operation - too many requests
        '500':
          $ref: '#/components/responses/Error500ResponseBody'
          description: >-
            Internal Server error for AuditEvent Search operation - unexpected
            server error
      x-codeSamples:
        - lang: csharp
          label: Csharp (SDK)
          source: >-
            using Meitner;

            using Meitner.Models.Components;

            using System;

            using System.Collections.Generic;


            var sdk = new MeitnerSDK(security: new Security() {
                Option1 = new SecurityOption1() {
                    ClientCredentials = "<YOUR_API_KEY_HERE>",
                    ClientSecret = "<YOUR_API_KEY_HERE>",
                },
            });


            Models.Requests.AuditEventSearchResponse? res = await
            sdk.AuditEvents.SearchAsync(
                auditEventSearch: new AuditEventSearchRequestBody() {
                    Filter = new AuditEventSearchFilter() {
                        Equals = new AuditEventSearchEquals() {
                            Id = "123e4567-e89b-12d3-a456-426614174000",
                            Meta = new AuditEventSearchEqualsMeta() {
                                CreatedAt = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                                CreatedBy = "123e4567-e89b-12d3-a456-426614174000",
                                UpdatedAt = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                                UpdatedBy = "123e4567-e89b-12d3-a456-426614174000",
                            },
                            Timestamp = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                            ResourceID = "123e4567-e89b-12d3-a456-426614174000",
                        },
                        NotEquals = new AuditEventSearchNotEquals() {
                            Id = "123e4567-e89b-12d3-a456-426614174000",
                            Meta = new AuditEventSearchNotEqualsMeta() {
                                CreatedAt = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                                CreatedBy = "123e4567-e89b-12d3-a456-426614174000",
                                UpdatedAt = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                                UpdatedBy = "123e4567-e89b-12d3-a456-426614174000",
                            },
                            Timestamp = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                            ResourceID = "123e4567-e89b-12d3-a456-426614174000",
                        },
                        GreaterThan = new AuditEventSearchGreaterThan() {
                            Meta = new AuditEventSearchGreaterThanMeta() {
                                CreatedAt = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                                UpdatedAt = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                            },
                            Timestamp = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                        },
                        SmallerThan = new AuditEventSearchSmallerThan() {
                            Meta = new AuditEventSearchSmallerThanMeta() {
                                CreatedAt = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                                UpdatedAt = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                            },
                            Timestamp = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                        },
                        GreaterOrEqual = new AuditEventSearchGreaterOrEqual() {
                            Meta = new AuditEventSearchGreaterOrEqualMeta() {
                                CreatedAt = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                                UpdatedAt = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                            },
                            Timestamp = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                        },
                        SmallerOrEqual = new AuditEventSearchSmallerOrEqual() {
                            Meta = new AuditEventSearchSmallerOrEqualMeta() {
                                CreatedAt = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                                UpdatedAt = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                            },
                            Timestamp = System.DateTime.Parse("2024-01-15T10:30:00Z").ToUniversalTime(),
                        },
                        Contains = new AuditEventSearchContains() {
                            Id = new List<string>() {
                                "123e4567-e89b-12d3-a456-426614174000",
                            },
                            Meta = new AuditEventSearchContainsMeta() {
                                CreatedBy = new List<string>() {
                                    "123e4567-e89b-12d3-a456-426614174000",
                                },
                                UpdatedBy = new List<string>() {
                                    "123e4567-e89b-12d3-a456-426614174000",
                                },
                            },
                            ResourceID = new List<string>() {
                                "123e4567-e89b-12d3-a456-426614174000",
                            },
                        },
                        NotContains = new AuditEventSearchNotContains() {
                            Id = new List<string>() {
                                "123e4567-e89b-12d3-a456-426614174000",
                            },
                            Meta = new AuditEventSearchNotContainsMeta() {
                                CreatedBy = new List<string>() {
                                    "123e4567-e89b-12d3-a456-426614174000",
                                },
                                UpdatedBy = new List<string>() {
                                    "123e4567-e89b-12d3-a456-426614174000",
                                },
                            },
                            ResourceID = new List<string>() {
                                "123e4567-e89b-12d3-a456-426614174000",
                            },
                        },
                        Null = new AuditEventSearchNull() {
                            Meta = new AuditEventSearchNullMeta() {
                                CreatedBy = true,
                                UpdatedAt = true,
                                UpdatedBy = true,
                            },
                        },
                        NotNull = new AuditEventSearchNotNull() {
                            Meta = new AuditEventSearchNotNullMeta() {
                                CreatedBy = true,
                                UpdatedAt = true,
                                UpdatedBy = true,
                            },
                        },
                        OrCondition = true,
                    },
                },
                limit: 1,
                offset: 0
            );


            while(res != null)

            {
                // handle items

                res = await res.Next!();
            }
        - lang: python
          label: Python (SDK)
          source: |-
            from meitner import Meitner, models
            from meitner.utils import parse_datetime
            import os


            with Meitner(
                security=models.Security(
                    option1=models.SecurityOption1(
                        client_credentials=os.getenv("MEITNER_CLIENT_CREDENTIALS", ""),
                        client_secret=os.getenv("MEITNER_CLIENT_SECRET", ""),
                    ),
                ),
            ) as m_client:

                res = m_client.audit_events.search(filter_={
                    "equals": {
                        "id": "123e4567-e89b-12d3-a456-426614174000",
                        "meta": {
                            "created_at": parse_datetime("2024-01-15T10:30:00Z"),
                            "created_by": "123e4567-e89b-12d3-a456-426614174000",
                            "updated_at": parse_datetime("2024-01-15T10:30:00Z"),
                            "updated_by": "123e4567-e89b-12d3-a456-426614174000",
                        },
                        "timestamp": parse_datetime("2024-01-15T10:30:00Z"),
                        "resource_id": "123e4567-e89b-12d3-a456-426614174000",
                    },
                    "not_equals": {
                        "id": "123e4567-e89b-12d3-a456-426614174000",
                        "meta": {
                            "created_at": parse_datetime("2024-01-15T10:30:00Z"),
                            "created_by": "123e4567-e89b-12d3-a456-426614174000",
                            "updated_at": parse_datetime("2024-01-15T10:30:00Z"),
                            "updated_by": "123e4567-e89b-12d3-a456-426614174000",
                        },
                        "timestamp": parse_datetime("2024-01-15T10:30:00Z"),
                        "resource_id": "123e4567-e89b-12d3-a456-426614174000",
                    },
                    "greater_than": {
                        "meta": {
                            "created_at": parse_datetime("2024-01-15T10:30:00Z"),
                            "updated_at": parse_datetime("2024-01-15T10:30:00Z"),
                        },
                        "timestamp": parse_datetime("2024-01-15T10:30:00Z"),
                    },
                    "smaller_than": {
                        "meta": {
                            "created_at": parse_datetime("2024-01-15T10:30:00Z"),
                            "updated_at": parse_datetime("2024-01-15T10:30:00Z"),
                        },
                        "timestamp": parse_datetime("2024-01-15T10:30:00Z"),
                    },
                    "greater_or_equal": {
                        "meta": {
                            "created_at": parse_datetime("2024-01-15T10:30:00Z"),
                            "updated_at": parse_datetime("2024-01-15T10:30:00Z"),
                        },
                        "timestamp": parse_datetime("2024-01-15T10:30:00Z"),
                    },
                    "smaller_or_equal": {
                        "meta": {
                            "created_at": parse_datetime("2024-01-15T10:30:00Z"),
                            "updated_at": parse_datetime("2024-01-15T10:30:00Z"),
                        },
                        "timestamp": parse_datetime("2024-01-15T10:30:00Z"),
                    },
                    "contains": {
                        "id": [
                            "123e4567-e89b-12d3-a456-426614174000",
                        ],
                        "meta": {
                            "created_by": [
                                "123e4567-e89b-12d3-a456-426614174000",
                            ],
                            "updated_by": [
                                "123e4567-e89b-12d3-a456-426614174000",
                            ],
                        },
                        "resource_id": [
                            "123e4567-e89b-12d3-a456-426614174000",
                        ],
                    },
                    "not_contains": {
                        "id": [
                            "123e4567-e89b-12d3-a456-426614174000",
                        ],
                        "meta": {
                            "created_by": [
                                "123e4567-e89b-12d3-a456-426614174000",
                            ],
                            "updated_by": [
                                "123e4567-e89b-12d3-a456-426614174000",
                            ],
                        },
                        "resource_id": [
                            "123e4567-e89b-12d3-a456-426614174000",
                        ],
                    },
                    "null": {
                        "meta": {
                            "created_by": True,
                            "updated_at": True,
                            "updated_by": True,
                        },
                    },
                    "not_null": {
                        "meta": {
                            "created_by": True,
                            "updated_at": True,
                            "updated_by": True,
                        },
                    },
                    "or_condition": True,
                }, limit=1, offset=0)

                while res is not None:
                    # Handle items

                    res = res.next()
components:
  requestBodies:
    AuditEventSearch:
      description: Request body
      content:
        application/json:
          schema:
            type: object
            properties:
              filter:
                allOf:
                  - $ref: '#/components/schemas/AuditEventFilter'
                examples:
                  - equals:
                      id: 123e4567-e89b-12d3-a456-426614174000
                      meta:
                        createdAt: '2024-01-15T10:30:00Z'
                        createdBy: 123e4567-e89b-12d3-a456-426614174000
                        updatedAt: '2024-01-15T10:30:00Z'
                        updatedBy: 123e4567-e89b-12d3-a456-426614174000
                      timestamp: '2024-01-15T10:30:00Z'
                      resourceID: 123e4567-e89b-12d3-a456-426614174000
                    notEquals:
                      id: 123e4567-e89b-12d3-a456-426614174000
                      meta:
                        createdAt: '2024-01-15T10:30:00Z'
                        createdBy: 123e4567-e89b-12d3-a456-426614174000
                        updatedAt: '2024-01-15T10:30:00Z'
                        updatedBy: 123e4567-e89b-12d3-a456-426614174000
                      timestamp: '2024-01-15T10:30:00Z'
                      resourceID: 123e4567-e89b-12d3-a456-426614174000
                    greaterThan:
                      meta:
                        createdAt: '2024-01-15T10:30:00Z'
                        updatedAt: '2024-01-15T10:30:00Z'
                      timestamp: '2024-01-15T10:30:00Z'
                    smallerThan:
                      meta:
                        createdAt: '2024-01-15T10:30:00Z'
                        updatedAt: '2024-01-15T10:30:00Z'
                      timestamp: '2024-01-15T10:30:00Z'
                    greaterOrEqual:
                      meta:
                        createdAt: '2024-01-15T10:30:00Z'
                        updatedAt: '2024-01-15T10:30:00Z'
                      timestamp: '2024-01-15T10:30:00Z'
                    smallerOrEqual:
                      meta:
                        createdAt: '2024-01-15T10:30:00Z'
                        updatedAt: '2024-01-15T10:30:00Z'
                      timestamp: '2024-01-15T10:30:00Z'
                    contains:
                      id:
                        - 123e4567-e89b-12d3-a456-426614174000
                      meta:
                        createdBy:
                          - 123e4567-e89b-12d3-a456-426614174000
                        updatedBy:
                          - 123e4567-e89b-12d3-a456-426614174000
                      resourceID:
                        - 123e4567-e89b-12d3-a456-426614174000
                    notContains:
                      id:
                        - 123e4567-e89b-12d3-a456-426614174000
                      meta:
                        createdBy:
                          - 123e4567-e89b-12d3-a456-426614174000
                        updatedBy:
                          - 123e4567-e89b-12d3-a456-426614174000
                      resourceID:
                        - 123e4567-e89b-12d3-a456-426614174000
                    'null':
                      meta:
                        createdBy: true
                        updatedAt: true
                        updatedBy: true
                    notNull:
                      meta:
                        createdBy: true
                        updatedAt: true
                        updatedBy: true
                    orCondition: true
                description: Filter criteria to search for specific records
            required:
              - filter
          examples:
            requestExample:
              summary: Request body example
              value:
                filter:
                  equals:
                    id: 123e4567-e89b-12d3-a456-426614174000
                    meta:
                      createdAt: '2024-01-15T10:30:00Z'
                      createdBy: 123e4567-e89b-12d3-a456-426614174000
                      updatedAt: '2024-01-15T10:30:00Z'
                      updatedBy: 123e4567-e89b-12d3-a456-426614174000
                    timestamp: '2024-01-15T10:30:00Z'
                    resourceID: 123e4567-e89b-12d3-a456-426614174000
                  notEquals:
                    id: 123e4567-e89b-12d3-a456-426614174000
                    meta:
                      createdAt: '2024-01-15T10:30:00Z'
                      createdBy: 123e4567-e89b-12d3-a456-426614174000
                      updatedAt: '2024-01-15T10:30:00Z'
                      updatedBy: 123e4567-e89b-12d3-a456-426614174000
                    timestamp: '2024-01-15T10:30:00Z'
                    resourceID: 123e4567-e89b-12d3-a456-426614174000
                  greaterThan:
                    meta:
                      createdAt: '2024-01-15T10:30:00Z'
                      updatedAt: '2024-01-15T10:30:00Z'
                    timestamp: '2024-01-15T10:30:00Z'
                  smallerThan:
                    meta:
                      createdAt: '2024-01-15T10:30:00Z'
                      updatedAt: '2024-01-15T10:30:00Z'
                    timestamp: '2024-01-15T10:30:00Z'
                  greaterOrEqual:
                    meta:
                      createdAt: '2024-01-15T10:30:00Z'
                      updatedAt: '2024-01-15T10:30:00Z'
                    timestamp: '2024-01-15T10:30:00Z'
                  smallerOrEqual:
                    meta:
                      createdAt: '2024-01-15T10:30:00Z'
                      updatedAt: '2024-01-15T10:30:00Z'
                    timestamp: '2024-01-15T10:30:00Z'
                  contains:
                    id:
                      - 123e4567-e89b-12d3-a456-426614174000
                    meta:
                      createdBy:
                        - 123e4567-e89b-12d3-a456-426614174000
                      updatedBy:
                        - 123e4567-e89b-12d3-a456-426614174000
                    resourceID:
                      - 123e4567-e89b-12d3-a456-426614174000
                  notContains:
                    id:
                      - 123e4567-e89b-12d3-a456-426614174000
                    meta:
                      createdBy:
                        - 123e4567-e89b-12d3-a456-426614174000
                      updatedBy:
                        - 123e4567-e89b-12d3-a456-426614174000
                    resourceID:
                      - 123e4567-e89b-12d3-a456-426614174000
                  'null':
                    meta:
                      createdBy: true
                      updatedAt: true
                      updatedBy: true
                  notNull:
                    meta:
                      createdBy: true
                      updatedAt: true
                      updatedBy: true
                  orCondition: true
      required: true
  responses:
    AuditEventSearch:
      description: >-
        Response for AuditEvent Search operation - returns filtered AuditEvent
        results
      headers:
        RateLimit-Limit:
          description: >-
            The maximum number of API requests you're permitted to make per
            hour.
          schema:
            type: integer
            examples:
              - 5000
        RateLimit-Remaining:
          description: >-
            The number of API requests remaining in the current rate limit
            window.
          schema:
            type: integer
            examples:
              - 4999
        RateLimit-Reset:
          description: >-
            The time at which the current rate limit window resets in UTC epoch
            milliseconds.
          schema:
            type: string
            examples:
              - '1728316800000'
      content:
        application/json:
          schema:
            type: object
            properties:
              data:
                type: array
                examples:
                  - - id: 123e4567-e89b-12d3-a456-426614174000
                      meta:
                        createdAt: '2024-01-15T10:30:00Z'
                        createdBy: 987fcdeb-51a2-43d1-b567-123456789abc
                        updatedAt: '2024-01-15T14:45:00Z'
                        updatedBy: 987fcdeb-51a2-43d1-b567-123456789abc
                      timestamp: '2024-08-01T00:00:00Z'
                      resource: Student
                      resourceID: 123e4567-e89b-12d3-a456-426614174000
                      type: Delete
                items:
                  allOf:
                    - $ref: '#/components/schemas/AuditEvent'
                description: Array of AuditEvent objects
              pagination:
                allOf:
                  - $ref: '#/components/schemas/Pagination'
                examples:
                  - offset: 0
                    limit: 1
                    total: 100
                description: Pagination information
          examples:
            responseExample:
              summary: Response body example
              value:
                data:
                  - id: 123e4567-e89b-12d3-a456-426614174000
                    meta:
                      createdAt: '2024-01-15T10:30:00Z'
                      createdBy: 987fcdeb-51a2-43d1-b567-123456789abc
                      updatedAt: '2024-01-15T14:45:00Z'
                      updatedBy: 987fcdeb-51a2-43d1-b567-123456789abc
                    timestamp: '2024-08-01T00:00:00Z'
                    resource: Student
                    resourceID: 123e4567-e89b-12d3-a456-426614174000
                    type: Delete
                pagination:
                  offset: 0
                  limit: 1
                  total: 100
    Error400ResponseBody:
      description: Bad Request - The request was malformed or contained invalid parameters
      headers:
        RateLimit-Limit:
          description: >-
            The maximum number of API requests you're permitted to make per
            hour.
          schema:
            type: integer
            examples:
              - 5000
        RateLimit-Remaining:
          description: >-
            The number of API requests remaining in the current rate limit
            window.
          schema:
            type: integer
            examples:
              - 4999
        RateLimit-Reset:
          description: >-
            The time at which the current rate limit window resets in UTC epoch
            milliseconds.
          schema:
            type: string
            examples:
              - '1728316800000'
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                allOf:
                  - $ref: '#/components/schemas/Error'
                examples:
                  - code: BadRequest
                    message: The request contains invalid parameters or malformed data
                    requestID: 550e8400-e29b-41d4-a716-446655440000
            required:
              - error
          examples:
            errorExample:
              summary: Bad Request error example
              value:
                error:
                  code: BadRequest
                  message: The request contains invalid parameters or malformed data
                  requestID: 550e8400-e29b-41d4-a716-446655440000
    Error401ResponseBody:
      description: Unauthorized - The request is missing valid authentication credentials
      headers:
        RateLimit-Limit:
          description: >-
            The maximum number of API requests you're permitted to make per
            hour.
          schema:
            type: integer
            examples:
              - 5000
        RateLimit-Remaining:
          description: >-
            The number of API requests remaining in the current rate limit
            window.
          schema:
            type: integer
            examples:
              - 4999
        RateLimit-Reset:
          description: >-
            The time at which the current rate limit window resets in UTC epoch
            milliseconds.
          schema:
            type: string
            examples:
              - '1728316800000'
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                allOf:
                  - $ref: '#/components/schemas/Error'
                examples:
                  - code: BadRequest
                    message: The request contains invalid parameters or malformed data
                    requestID: 550e8400-e29b-41d4-a716-446655440000
            required:
              - error
          examples:
            errorExample:
              summary: Unauthorized error example
              value:
                error:
                  code: Unauthorized
                  message: Authentication credentials are missing or invalid
                  requestID: 550e8400-e29b-41d4-a716-446655440000
    Error403ResponseBody:
      description: >-
        Forbidden - Request is authenticated, but the user is not allowed to
        perform the operation
      headers:
        RateLimit-Limit:
          description: >-
            The maximum number of API requests you're permitted to make per
            hour.
          schema:
            type: integer
            examples:
              - 5000
        RateLimit-Remaining:
          description: >-
            The number of API requests remaining in the current rate limit
            window.
          schema:
            type: integer
            examples:
              - 4999
        RateLimit-Reset:
          description: >-
            The time at which the current rate limit window resets in UTC epoch
            milliseconds.
          schema:
            type: string
            examples:
              - '1728316800000'
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                allOf:
                  - $ref: '#/components/schemas/Error'
                examples:
                  - code: BadRequest
                    message: The request contains invalid parameters or malformed data
                    requestID: 550e8400-e29b-41d4-a716-446655440000
            required:
              - error
          examples:
            errorExample:
              summary: Forbidden error example
              value:
                error:
                  code: Forbidden
                  message: You do not have permission to perform this operation
                  requestID: 550e8400-e29b-41d4-a716-446655440000
    Error404ResponseBody:
      description: Not Found - The requested resource does not exist
      headers:
        RateLimit-Limit:
          description: >-
            The maximum number of API requests you're permitted to make per
            hour.
          schema:
            type: integer
            examples:
              - 5000
        RateLimit-Remaining:
          description: >-
            The number of API requests remaining in the current rate limit
            window.
          schema:
            type: integer
            examples:
              - 4999
        RateLimit-Reset:
          description: >-
            The time at which the current rate limit window resets in UTC epoch
            milliseconds.
          schema:
            type: string
            examples:
              - '1728316800000'
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                allOf:
                  - $ref: '#/components/schemas/Error'
                examples:
                  - code: BadRequest
                    message: The request contains invalid parameters or malformed data
                    requestID: 550e8400-e29b-41d4-a716-446655440000
            required:
              - error
          examples:
            errorExample:
              summary: Not Found error example
              value:
                error:
                  code: NotFound
                  message: The requested resource could not be found
                  requestID: 550e8400-e29b-41d4-a716-446655440000
    Error409ResponseBody:
      description: Conflict - The request could not be completed due to a conflict
      headers:
        RateLimit-Limit:
          description: >-
            The maximum number of API requests you're permitted to make per
            hour.
          schema:
            type: integer
            examples:
              - 5000
        RateLimit-Remaining:
          description: >-
            The number of API requests remaining in the current rate limit
            window.
          schema:
            type: integer
            examples:
              - 4999
        RateLimit-Reset:
          description: >-
            The time at which the current rate limit window resets in UTC epoch
            milliseconds.
          schema:
            type: string
            examples:
              - '1728316800000'
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                allOf:
                  - $ref: '#/components/schemas/Error'
                examples:
                  - code: BadRequest
                    message: The request contains invalid parameters or malformed data
                    requestID: 550e8400-e29b-41d4-a716-446655440000
            required:
              - error
          examples:
            errorExample:
              summary: Conflict error example
              value:
                error:
                  code: Conflict
                  message: The request conflicts with the current state of the resource
                  requestID: 550e8400-e29b-41d4-a716-446655440000
    AuditEventSearch422ResponseBody:
      description: >-
        Validation error for AuditEvent Search operation - request data failed
        validation
      headers:
        RateLimit-Limit:
          description: >-
            The maximum number of API requests you're permitted to make per
            hour.
          schema:
            type: integer
            examples:
              - 5000
        RateLimit-Remaining:
          description: >-
            The number of API requests remaining in the current rate limit
            window.
          schema:
            type: integer
            examples:
              - 4999
        RateLimit-Reset:
          description: >-
            The time at which the current rate limit window resets in UTC epoch
            milliseconds.
          schema:
            type: string
            examples:
              - '1728316800000'
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                allOf:
                  - $ref: '#/components/schemas/Error'
                examples:
                  - code: UnprocessableEntity
                    message: Validation failed for AuditEvent Search endpoint
                    requestID: 550e8400-e29b-41d4-a716-446655440000
            required:
              - error
          examples:
            validationError:
              summary: Validation error example
              value:
                error:
                  code: UnprocessableEntity
                  message: Validation failed for AuditEvent Search endpoint
                  requestID: 550e8400-e29b-41d4-a716-446655440000
    Error429ResponseBody:
      description: Too Many Requests - When the rate limit has been exceeded
      headers:
        RateLimit-Limit:
          description: >-
            The maximum number of API requests you're permitted to make per
            hour.
          schema:
            type: integer
            examples:
              - 5000
        RateLimit-Remaining:
          description: >-
            The number of API requests remaining in the current rate limit
            window.
          schema:
            type: integer
            examples:
              - 4999
        RateLimit-Reset:
          description: >-
            The time at which the current rate limit window resets in UTC epoch
            milliseconds.
          schema:
            type: string
            examples:
              - '1728316800000'
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                allOf:
                  - $ref: '#/components/schemas/Error'
                examples:
                  - code: BadRequest
                    message: The request contains invalid parameters or malformed data
                    requestID: 550e8400-e29b-41d4-a716-446655440000
            required:
              - error
          examples:
            errorExample:
              summary: Rate Limited error example
              value:
                error:
                  code: RateLimited
                  message: Too many requests - rate limit exceeded
                  requestID: 550e8400-e29b-41d4-a716-446655440000
    Error500ResponseBody:
      description: Internal Server Error - An unexpected server error occurred
      headers:
        RateLimit-Limit:
          description: >-
            The maximum number of API requests you're permitted to make per
            hour.
          schema:
            type: integer
            examples:
              - 5000
        RateLimit-Remaining:
          description: >-
            The number of API requests remaining in the current rate limit
            window.
          schema:
            type: integer
            examples:
              - 4999
        RateLimit-Reset:
          description: >-
            The time at which the current rate limit window resets in UTC epoch
            milliseconds.
          schema:
            type: string
            examples:
              - '1728316800000'
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                allOf:
                  - $ref: '#/components/schemas/Error'
                examples:
                  - code: BadRequest
                    message: The request contains invalid parameters or malformed data
                    requestID: 550e8400-e29b-41d4-a716-446655440000
            required:
              - error
          examples:
            errorExample:
              summary: Internal Server error example
              value:
                error:
                  code: Internal
                  message: An unexpected server error occurred
                  requestID: 550e8400-e29b-41d4-a716-446655440000
  schemas:
    AuditEventFilter:
      type: object
      properties:
        equals:
          allOf:
            - $ref: '#/components/schemas/AuditEventFilterEquals'
          examples:
            - id: 123e4567-e89b-12d3-a456-426614174000
              meta:
                createdAt: '2024-01-15T10:30:00Z'
                createdBy: 123e4567-e89b-12d3-a456-426614174000
                updatedAt: '2024-01-15T10:30:00Z'
                updatedBy: 123e4567-e89b-12d3-a456-426614174000
              timestamp: '2024-01-15T10:30:00Z'
              resourceID: 123e4567-e89b-12d3-a456-426614174000
            - null
          description: Equality filters for AuditEvent
          nullable: true
        notEquals:
          allOf:
            - $ref: '#/components/schemas/AuditEventFilterEquals'
          examples:
            - id: 123e4567-e89b-12d3-a456-426614174000
              meta:
                createdAt: '2024-01-15T10:30:00Z'
                createdBy: 123e4567-e89b-12d3-a456-426614174000
                updatedAt: '2024-01-15T10:30:00Z'
                updatedBy: 123e4567-e89b-12d3-a456-426614174000
              timestamp: '2024-01-15T10:30:00Z'
              resourceID: 123e4567-e89b-12d3-a456-426614174000
            - null
          description: Inequality filters for AuditEvent
          nullable: true
        greaterThan:
          allOf:
            - $ref: '#/components/schemas/AuditEventFilterRange'
          examples:
            - meta:
                createdAt: '2024-01-15T10:30:00Z'
                updatedAt: '2024-01-15T10:30:00Z'
              timestamp: '2024-01-15T10:30:00Z'
            - null
          description: Greater than filters for AuditEvent
          nullable: true
        smallerThan:
          allOf:
            - $ref: '#/components/schemas/AuditEventFilterRange'
          examples:
            - meta:
                createdAt: '2024-01-15T10:30:00Z'
                updatedAt: '2024-01-15T10:30:00Z'
              timestamp: '2024-01-15T10:30:00Z'
            - null
          description: Smaller than filters for AuditEvent
          nullable: true
        greaterOrEqual:
          allOf:
            - $ref: '#/components/schemas/AuditEventFilterRange'
          examples:
            - meta:
                createdAt: '2024-01-15T10:30:00Z'
                updatedAt: '2024-01-15T10:30:00Z'
              timestamp: '2024-01-15T10:30:00Z'
            - null
          description: Greater than or equal filters for AuditEvent
          nullable: true
        smallerOrEqual:
          allOf:
            - $ref: '#/components/schemas/AuditEventFilterRange'
          examples:
            - meta:
                createdAt: '2024-01-15T10:30:00Z'
                updatedAt: '2024-01-15T10:30:00Z'
              timestamp: '2024-01-15T10:30:00Z'
            - null
          description: Smaller than or equal filters for AuditEvent
          nullable: true
        contains:
          allOf:
            - $ref: '#/components/schemas/AuditEventFilterContains'
          examples:
            - id:
                - 123e4567-e89b-12d3-a456-426614174000
              meta:
                createdBy:
                  - 123e4567-e89b-12d3-a456-426614174000
                updatedBy:
                  - 123e4567-e89b-12d3-a456-426614174000
              resourceID:
                - 123e4567-e89b-12d3-a456-426614174000
            - null
          description: Contains filters for AuditEvent
          nullable: true
        notContains:
          allOf:
            - $ref: '#/components/schemas/AuditEventFilterContains'
          examples:
            - id:
                - 123e4567-e89b-12d3-a456-426614174000
              meta:
                createdBy:
                  - 123e4567-e89b-12d3-a456-426614174000
                updatedBy:
                  - 123e4567-e89b-12d3-a456-426614174000
              resourceID:
                - 123e4567-e89b-12d3-a456-426614174000
            - null
          description: Not contains filters for AuditEvent
          nullable: true
        like:
          allOf:
            - $ref: '#/components/schemas/AuditEventFilterLike'
          description: LIKE filters for AuditEvent
          nullable: true
        notLike:
          allOf:
            - $ref: '#/components/schemas/AuditEventFilterLike'
          description: NOT LIKE filters for AuditEvent
          nullable: true
        'null':
          allOf:
            - $ref: '#/components/schemas/AuditEventFilterNull'
          examples:
            - meta:
                createdBy: true
                updatedAt: true
                updatedBy: true
            - null
          description: Null filters for AuditEvent
          nullable: true
        notNull:
          allOf:
            - $ref: '#/components/schemas/AuditEventFilterNull'
          examples:
            - meta:
                createdBy: true
                updatedAt: true
                updatedBy: true
            - null
          description: Not null filters for AuditEvent
          nullable: true
        orCondition:
          type: boolean
          examples:
            - true
          description: >-
            OrCondition decides if this filter is within an OR-condition or
            AND-condition
        nestedFilters:
          type: array
          examples:
            - - equals:
                  id: 123e4567-e89b-12d3-a456-426614174000
                  meta:
                    createdAt: '2024-01-15T10:30:00Z'
                    createdBy: 123e4567-e89b-12d3-a456-426614174000
                    updatedAt: '2024-01-15T10:30:00Z'
                    updatedBy: 123e4567-e89b-12d3-a456-426614174000
                  timestamp: '2024-01-15T10:30:00Z'
                  resourceID: 123e4567-e89b-12d3-a456-426614174000
                notEquals:
                  id: 123e4567-e89b-12d3-a456-426614174000
                  meta:
                    createdAt: '2024-01-15T10:30:00Z'
                    createdBy: 123e4567-e89b-12d3-a456-426614174000
                    updatedAt: '2024-01-15T10:30:00Z'
                    updatedBy: 123e4567-e89b-12d3-a456-426614174000
                  timestamp: '2024-01-15T10:30:00Z'
                  resourceID: 123e4567-e89b-12d3-a456-426614174000
                greaterThan:
                  meta:
                    createdAt: '2024-01-15T10:30:00Z'
                    updatedAt: '2024-01-15T10:30:00Z'
                  timestamp: '2024-01-15T10:30:00Z'
                smallerThan:
                  meta:
                    createdAt: '2024-01-15T10:30:00Z'
                    updatedAt: '2024-01-15T10:30:00Z'
                  timestamp: '2024-01-15T10:30:00Z'
                greaterOrEqual:
                  meta:
                    createdAt: '2024-01-15T10:30:00Z'
                    updatedAt: '2024-01-15T10:30:00Z'
                  timestamp: '2024-01-15T10:30:00Z'
                smallerOrEqual:
                  meta:
                    createdAt: '2024-01-15T10:30:00Z'
                    updatedAt: '2024-01-15T10:30:00Z'
                  timestamp: '2024-01-15T10:30:00Z'
                contains:
                  id:
                    - 123e4567-e89b-12d3-a456-426614174000
                  meta:
                    createdBy:
                      - 123e4567-e89b-12d3-a456-426614174000
                    updatedBy:
                      - 123e4567-e89b-12d3-a456-426614174000
                  resourceID:
                    - 123e4567-e89b-12d3-a456-426614174000
                notContains:
                  id:
                    - 123e4567-e89b-12d3-a456-426614174000
                  meta:
                    createdBy:
                      - 123e4567-e89b-12d3-a456-426614174000
                    updatedBy:
                      - 123e4567-e89b-12d3-a456-426614174000
                  resourceID:
                    - 123e4567-e89b-12d3-a456-426614174000
                'null':
                  meta:
                    createdBy: true
                    updatedAt: true
                    updatedBy: true
                notNull:
                  meta:
                    createdBy: true
                    updatedAt: true
                    updatedBy: true
                orCondition: true
          items:
            allOf:
              - $ref: '#/components/schemas/AuditEventFilter'
          description: NestedFilters of the AuditEvent, useful for more complex filters
      required:
        - orCondition
      description: Filter object for AuditEvent
    AuditEvent:
      type: object
      properties:
        id:
          type: string
          examples:
            - 123e4567-e89b-12d3-a456-426614174000
          format: uuid
          description: Unique identifier for the AuditEvent
        meta:
          allOf:
            - $ref: '#/components/schemas/Meta'
          examples:
            - createdAt: '2024-01-15T10:30:00Z'
              createdBy: 987fcdeb-51a2-43d1-b567-123456789abc
              updatedAt: '2024-01-15T14:45:00Z'
              updatedBy: 987fcdeb-51a2-43d1-b567-123456789abc
          description: Metadata information for the AuditEvent
        timestamp:
          type: string
          examples:
            - '2024-08-01T00:00:00Z'
          format: date-time
          description: The timestamp of the event
        resource:
          allOf:
            - $ref: '#/components/schemas/AuditEventResource'
          examples:
            - Student
          description: The type of resource the event occured for
        resourceID:
          type: string
          examples:
            - 123e4567-e89b-12d3-a456-426614174000
          format: uuid
          description: The ID of the resource the event belongs to
        type:
          allOf:
            - $ref: '#/components/schemas/AuditEventType'
          examples:
            - Delete
          description: The type of the audit event
      required:
        - id
        - timestamp
        - resource
        - resourceID
        - type
      description: AuditEvent holds the information about an audit event.
    Pagination:
      type: object
      properties:
        offset:
          type: integer
          examples:
            - 0
          description: Number of items to skip from the beginning of the result set
        limit:
          type: integer
          examples:
            - 1
          description: Maximum number of items to return in the result set
        total:
          type: integer
          examples:
            - 100
          description: Total number of items available for pagination
      required:
        - offset
        - limit
        - total
      description: Pagination parameters for controlling result sets in list operations
    Error:
      type: object
      properties:
        code:
          allOf:
            - $ref: '#/components/schemas/ErrorCode'
          description: The specific error code indicating the type of error
        message:
          type: string
          examples:
            - example
          description: Human-readable error message providing additional details
        requestID:
          type: string
          examples:
            - 550e8400-e29b-41d4-a716-446655440000
          description: >-
            Unique identifier for the request that generated this error, used
            for logging and debugging
      required:
        - code
        - message
        - requestID
      description: >-
        Standard error response object containing error code, message, and
        request ID
    AuditEventFilterEquals:
      type: object
      properties:
        id:
          type: string
          examples:
            - 123e4567-e89b-12d3-a456-426614174000
            - null
          format: uuid
          description: Unique identifier for the AuditEvent
          nullable: true
        meta:
          allOf:
            - $ref: '#/components/schemas/MetaFilterEquals'
          examples:
            - createdAt: '2024-01-15T10:30:00Z'
              createdBy: 123e4567-e89b-12d3-a456-426614174000
              updatedAt: '2024-01-15T10:30:00Z'
              updatedBy: 123e4567-e89b-12d3-a456-426614174000
            - null
          description: Metadata information for the AuditEvent
          nullable: true
        timestamp:
          type: string
          examples:
            - '2024-01-15T10:30:00Z'
            - null
          format: date-time
          description: The timestamp of the event
          nullable: true
        resource:
          allOf:
            - $ref: '#/components/schemas/AuditEventResource'
          description: The type of resource the event occured for
          nullable: true
        resourceID:
          type: string
          examples:
            - 123e4567-e89b-12d3-a456-426614174000
            - null
          format: uuid
          description: The ID of the resource the event belongs to
          nullable: true
        type:
          allOf:
            - $ref: '#/components/schemas/AuditEventType'
          description: The type of the audit event
          nullable: true
      description: Equality/Inequality filter fields for AuditEvent
    AuditEventFilterRange:
      type: object
      properties:
        meta:
          allOf:
            - $ref: '#/components/schemas/MetaFilterRange'
          examples:
            - createdAt: '2024-01-15T10:30:00Z'
              updatedAt: '2024-01-15T10:30:00Z'
            - null
          description: Metadata information for the AuditEvent
          nullable: true
        timestamp:
          type: string
          examples:
            - '2024-01-15T10:30:00Z'
            - null
          format: date-time
          description: The timestamp of the event
          nullable: true
      description: Range filter fields for AuditEvent
    AuditEventFilterContains:
      type: object
      properties:
        id:
          type: array
          examples:
            - - 123e4567-e89b-12d3-a456-426614174000
          items:
            type: string
            format: uuid
          description: Unique identifier for the AuditEvent
        meta:
          allOf:
            - $ref: '#/components/schemas/MetaFilterContains'
          examples:
            - createdBy:
                - 123e4567-e89b-12d3-a456-426614174000
              updatedBy:
                - 123e4567-e89b-12d3-a456-426614174000
            - null
          description: Metadata information for the AuditEvent
          nullable: true
        resource:
          type: array
          items:
            allOf:
              - $ref: '#/components/schemas/AuditEventResource'
          description: The type of resource the event occured for
        resourceID:
          type: array
          examples:
            - - 123e4567-e89b-12d3-a456-426614174000
          items:
            type: string
            format: uuid
          description: The ID of the resource the event belongs to
        type:
          type: array
          items:
            allOf:
              - $ref: '#/components/schemas/AuditEventType'
          description: The type of the audit event
      description: Contains filter fields for AuditEvent
    AuditEventFilterLike:
      type: object
      properties:
        meta:
          allOf:
            - $ref: '#/components/schemas/MetaFilterLike'
          description: Metadata information for the AuditEvent
          nullable: true
      description: LIKE filter fields for AuditEvent
    AuditEventFilterNull:
      type: object
      properties:
        meta:
          allOf:
            - $ref: '#/components/schemas/MetaFilterNull'
          examples:
            - createdBy: true
              updatedAt: true
              updatedBy: true
            - null
          description: Metadata information for the AuditEvent
          nullable: true
      description: Null filter fields for AuditEvent
    Meta:
      type: object
      properties:
        createdAt:
          type: string
          examples:
            - '2024-01-15T10:30:00Z'
          format: date-time
          description: Timestamp when the resource was created
        createdBy:
          type: string
          examples:
            - 987fcdeb-51a2-43d1-b567-123456789abc
            - null
          format: uuid
          description: User who created the resource
          nullable: true
        updatedAt:
          type: string
          examples:
            - '2024-01-15T14:45:00Z'
            - null
          format: date-time
          description: Timestamp when the resource was last updated
          nullable: true
        updatedBy:
          type: string
          examples:
            - 987fcdeb-51a2-43d1-b567-123456789abc
            - null
          format: uuid
          description: User who last updated the resource
          nullable: true
      required:
        - createdAt
      description: >-
        Meta contains information about the creation and modification of a
        resource for auditing purposes
    AuditEventResource:
      type: string
      enum:
        - Group
        - Guardian
        - Employee
        - EmployeePlacement
        - Student
        - StudentPlacement
      description: The resource that was affected by the audit event
    AuditEventType:
      type: string
      enum:
        - Delete
      description: The type of the audit event
    ErrorCode:
      type: string
      enum:
        - BadRequest
        - Unauthorized
        - Forbidden
        - NotFound
        - Conflict
        - UnprocessableEntity
        - RateLimited
        - Internal
      description: Standard error codes used in API responses
    MetaFilterEquals:
      type: object
      properties:
        createdAt:
          type: string
          examples:
            - '2024-01-15T10:30:00Z'
            - null
          format: date-time
          description: Timestamp when the resource was created
          nullable: true
        createdBy:
          type: string
          examples:
            - 123e4567-e89b-12d3-a456-426614174000
            - null
          format: uuid
          description: User who created the resource
          nullable: true
        updatedAt:
          type: string
          examples:
            - '2024-01-15T10:30:00Z'
            - null
          format: date-time
          description: Timestamp when the resource was last updated
          nullable: true
        updatedBy:
          type: string
          examples:
            - 123e4567-e89b-12d3-a456-426614174000
            - null
          format: uuid
          description: User who last updated the resource
          nullable: true
      description: Equality/Inequality filter fields for Meta
    MetaFilterRange:
      type: object
      properties:
        createdAt:
          type: string
          examples:
            - '2024-01-15T10:30:00Z'
            - null
          format: date-time
          description: Timestamp when the resource was created
          nullable: true
        updatedAt:
          type: string
          examples:
            - '2024-01-15T10:30:00Z'
            - null
          format: date-time
          description: Timestamp when the resource was last updated
          nullable: true
      description: Range filter fields for Meta
    MetaFilterContains:
      type: object
      properties:
        createdBy:
          type: array
          examples:
            - - 123e4567-e89b-12d3-a456-426614174000
          items:
            type: string
            format: uuid
          description: User who created the resource
        updatedBy:
          type: array
          examples:
            - - 123e4567-e89b-12d3-a456-426614174000
          items:
            type: string
            format: uuid
          description: User who last updated the resource
      description: Contains filter fields for Meta
    MetaFilterLike:
      type: object
      description: LIKE filter fields for Meta
    MetaFilterNull:
      type: object
      properties:
        createdBy:
          type: boolean
          examples:
            - true
            - null
          description: User who created the resource
          nullable: true
        updatedAt:
          type: boolean
          examples:
            - true
            - null
          description: Timestamp when the resource was last updated
          nullable: true
        updatedBy:
          type: boolean
          examples:
            - true
            - null
          description: User who last updated the resource
          nullable: true
      description: Null filter fields for Meta
  securitySchemes:
    ClientCredentials:
      type: apiKey
      name: Client-ID
      in: header
    ClientSecret:
      type: apiKey
      name: Client-Secret
      in: header
    OAuth2:
      type: oauth2
      flows:
        clientCredentials:
          tokenUrl: /oauth/token
          scopes: {}

````